<template>
    <div id="switcher">
        <Inprototype />
        <div id="nav-switcher" @click="onSwitcher">
            <div id="switcher-info">
                <img :src="`${base}avatars/${section.icon}.png`" alt="GitLab">
                {{ section.label }}
            </div>
            <Icon v-if="isSwitcherOpen" icon="chevron-up" color="C-737278" />
            <Icon v-else icon="chevron-down" color="C-737278" />
        </div>
        <div id="switcher-list" v-if="isSwitcherOpen">
            <div id="switcher-search">
                <Icon icon='search' color="C-737278" />
                <input type="text" id="switcher-input" name="search" placeholder="Search for projects or groups">
            </div>
            <div id="switchto">
                <div id="switchto-label">Switch to...</div>
                <div class="switchto-item" @click="onYourwork">
                    <Icon icon='work' color="C-737278" />
                    <p class="switchto-item-label">Your work</p>
                </div>
                <div class="switchto-item" @click="onExplore">
                    <Icon icon='compass' color="C-737278" />
                    <p class="switchto-item-label">Explore</p>
                </div>
                <OrgSwitcher />
            </div>
            <div class="switchsection">
                <p class="switchsection-label">FREQUENT PROJECTS</p>
                <SwitcherItem v-for="item in user.switcher.projects" :label=item.label :desc=item.desc :icon=item.icon
                    :url=item.url :section=item.section />
            </div>
            <div class="switchsection">
                <p class="switchsection-label">FREQUENT GROUPS</p>
                <SwitcherItem v-for="item in user.switcher.groups" :label=item.label :desc=item.desc :icon=item.icon
                    :url=item.url :section=item.section />
            </div>
        </div>
    </div>
</template>

<script setup>
import { useMainStore } from '~~/stores/main';
import { storeToRefs } from 'pinia';

const main = useMainStore();
const { section, isSwitcherOpen, base } = storeToRefs(main);
const { setSwitcherOpen, onNavigate } = main;

const props = defineProps({
    user: {
        type: Object,
        required: false,
        default: {}
    }
});

const count = computed((icon, user) => {
    let n = null
    return n
});

function onSwitcher() {
    if (isSwitcherOpen.value === true) {
        setSwitcherOpen(false)
    } else {
        setSwitcherOpen(true)
    }
}

function onYourwork() {
    setSwitcherOpen(false);
    let dest = {}
    dest.url = `${section.value.org}-yourwork-projects`
    dest.section = {
        org: section.value.org,
        id: 'yourwork',
        label: 'Your work',
        icon: 'yourwork'
    }
    console.log('on your work', dest);
    onNavigate(dest);
}

function onExplore() {
    //TODO
    console.log('On Explore');
}

</script>

<style>
#nav-switcher:hover {
    background-color: #ECECEF;
}

#nav-switcher {
    display: flex;
    align-items: center;
    height: 40px;
    padding: 0 12px 0 12px;
    border-top: 1px solid #ECECEF;
    border-bottom: 1px solid #ECECEF;
}

#switcher-info {
    display: flex;
    flex-grow: 1;
    justify-content: flex-start;
    align-items: center;
    gap: 8px;
    color: #333238;
    font-size: 14px;
    font-weight: 600;
}

#switcher-info img {
    height: 24px;
    width: 24px;
}

#switcher-list {
    padding: 0 0 0 0;
    height: auto;
    animation: slide-in .3s ease-in;
    overflow-y: visible;
}

@keyframes slide-in {
    0% {
        height: 0px;
    }

    100% {
        height: 500px;
    }
}

#switcher-search {
    display: flex;
    justify-items: center;
    border-bottom: 1px solid #ECECEF;
    padding: 0 0 0 16px;
}

#switcher-search input {
    flex-grow: 1;
    border: none;
    height: 40px;
    padding: 0 0 0 8px;
    font-size: 12px;
    font-family: 'Inter', sans-serif;
}

#switchto {
    padding: 16px 0 8px 0;
}

#switchto-label {
    font-size: 12px;
    font-weight: bold;
    margin: 0 0 8px 12px;
}

.switchto-item {
    display: flex;
    align-items: center;
    gap: 8px;
    height: 32px;
    padding: 0 0 0 12px;
    font-size: 14px;
    line-height: 16px;
}

.switchto-item:hover {
    background-color: #ECECEF;
}

.switchsection {
    font-size: 10px;
    font-weight: 400px;
    color: #737278;
    border-top: 1px solid #ECECEF;
    padding: 16px 0 16px 4px;
    margin: 0 8px 0 8px;
}

.switchsection-label {
    font-size: 10px;
    font-weight: 400px;
    color: #737278;
    margin: 0 0 8px 0;
}
</style>